Index: /trunk/AddOn/TAcq/brbaseproc.cc
===================================================================
--- /trunk/AddOn/TAcq/brbaseproc.cc	(revision 3777)
+++ /trunk/AddOn/TAcq/brbaseproc.cc	(revision 3778)
@@ -34,4 +34,5 @@
   fgokallfibers_=true;
   totprocnpaq_=0;
+  setNameId("baseproc",0); 
 }
 
@@ -74,5 +75,5 @@
   int rc=0;
   try {
-    cout << " BRBaseProcessor::run() - Starting " << " NFibers=" << memgr_.NbFibres() 
+    cout << " BRBaseProcessor[" << bpid_ << "]::run() - Starting " << " NFibers=" << memgr_.NbFibres() 
 	 << " NChan=" << 2*memgr_.NbFibres() << endl;	
 
@@ -85,5 +86,5 @@
       Byte* buffg = memgr_.GetMemZone(mid);
       if (buffg == NULL) {
-	cout << "BRBaseProcessor::run()/ERROR memgr.GetMemZone(" << mid << ") -> NULL" << endl;
+	cout << "BRBaseProcessor[" << bpid_ << "]::run()/ERROR memgr.GetMemZone(" << mid << ") -> NULL" << endl;
 	setRC(7);      fgrun=false;		
 	break;	
@@ -92,5 +93,5 @@
 	fbuff_[fib] = memgr_.GetMemZone(mid,fib);
 	if (fbuff_[fib] == NULL) { // cela ne devrait pas arriver 
-	  cout << "BRBaseProcessor::run()/ERROR memgr.GetMemZone(" << mid << "," << fib << ") -> NULL" << endl;
+	  cout << "BRBaseProcessor[" << bpid_ << "]::run()/ERROR memgr.GetMemZone(" << mid << "," << fib << ") -> NULL" << endl;
 	  setRC(9);	  fgrun=false;		
 	  break;
@@ -121,5 +122,5 @@
     } // Fin de boucle sur les zones a traiter 
     //------------------------------------
-    cout << " --------- END BRBaseProcessor::run() , TotNbProcPaq=" << totprocnpaq_ << endl;
+    cout << " ---- END BRBaseProcessor[" << bpid_ << "]::run() , TotNbProcPaq=" << totprocnpaq_ << endl;
     /*
     for(size_t fib=0; fib<(size_t)memgr_.NbFibres(); fib++)  vpchk_[fib].Print();
@@ -128,10 +129,10 @@
   }
   catch (std::exception& exc) {
-    cout << " BRBaseProcessor::run()/catched std::exception " << exc.what() << endl;
+    cout << " BRBaseProcessor[" << bpid_ << "]::run()/catched std::exception " << exc.what() << endl;
     setRC(98);	
     return; 
   }
   catch(...) {
-    cout << " BRBaseProcessor::run()/catched unknown ... exception " << endl;
+    cout << " BRBaseProcessor[" << bpid_ << "]::run()/catched unknown ... exception " << endl;
     setRC(99);	
     return; 
Index: /trunk/AddOn/TAcq/brbaseproc.h
===================================================================
--- /trunk/AddOn/TAcq/brbaseproc.h	(revision 3777)
+++ /trunk/AddOn/TAcq/brbaseproc.h	(revision 3778)
@@ -32,4 +32,9 @@
   inline void STOP() { stop_ = true; }	
 
+  inline void setNameId(const char* nom, int id) 
+  { bpnom_=nom;   bpid_=id;  }
+  inline void setNameId(string nom, int id) 
+  { bpnom_=nom;   bpid_=id;  }
+
 protected:
   // Methode devant etre redefinie pour effectuer le traitement - appele pour chaque trigger  
@@ -50,4 +55,7 @@
 
   uint_8 totprocnpaq_; 
+
+  string bpnom_;    // nom du processeur
+  int bpid_;        // numero d'identificateur 
 };
 
Index: /trunk/AddOn/TAcq/brproc.cc
===================================================================
--- /trunk/AddOn/TAcq/brproc.cc	(revision 3777)
+++ /trunk/AddOn/TAcq/brproc.cc	(revision 3778)
@@ -69,4 +69,5 @@
   fgallfibok=NULL;
   fgcktt_=false;
+  setNameId("viscalc", 0); 
 }
 
@@ -118,4 +119,5 @@
     MemZaction mmzas[4]={MemZA_ProcA,MemZA_ProcB,MemZA_ProcC,MemZA_ProcD};
     SetMemZAction(mmzas[calcid_]);
+    setNameId("viscalc_grp", calcid_); 
   }
   return ;
@@ -204,5 +206,5 @@
       Byte* buffg = memgr_.GetMemZone(mid);
       if (buffg == NULL) {
-	cout << "BRVisibilityCalculator::run()/ERROR memgr.GetMemZone(" << mid << ") -> NULL" << endl;
+	cout << "BRVisibilityCalculator[" << calcid_ << "]::run()/ERROR memgr.GetMemZone(" << mid << ") -> NULL" << endl;
 	setRC(7);      fgrun=false;		
 	break;	
@@ -211,5 +213,5 @@
 	fbuff_[fib] = memgr_.GetMemZone(mid,fib);
 	if (fbuff_[fib] == NULL) { // cela ne devrait pas arriver 
-	  cout << "BRVisibilityCalculator::run()/ERROR memgr.GetMemZone(" << mid << "," << fib << ") -> NULL" << endl;
+	  cout << "BRVisibilityCalculator[" << calcid_ << "]::run()/ERROR memgr.GetMemZone(" << mid << "," << fib << ") -> NULL" << endl;
 	  setRC(9);	  fgrun=false;		
 	  break;
@@ -234,5 +236,5 @@
 	  POutPersist po(flnm);
 	  po << vismtx_;
-	  cout << numfile_ << "-BRVisibilityCalculator::run() NPaqProc="
+	  cout << numfile_ << "-BRVisibilityCalculator[" << calcid_ << "]::run() NPaqProc="
 	       << totnbpaq_ << "  -> Visibility Matrix in " << flnm << endl;
 	  FillVisibTable(moyfc_, moytt_);
@@ -267,10 +269,10 @@
       // Execution parallele  pour calcul des visibilites par bandes de frequence
       int rcpex=paralex_.execute();
-      if (rcpex!=0)  cout << " BRVisibilityCalculator::run() / Error Rc[paralex_.execute()]=" << rcpex << endl;
+      if (rcpex!=0)  cout << " BRVisibilityCalculator[" << calcid_ << "]::run() / Error Rc[paralex_.execute()]=" << rcpex << endl;
 
       memgr_.FreeMemZone(mid, mmsta_);  // (MemZS_ProcA);
     } // Fin de boucle sur les zones a traiter 
     //------------------------------------
-    cout << " --------- END BRVisibilityCalculator::run() , TotNbProcPaq=" << totprocnpaq_ << endl;
+    cout << " --------- END BRVisibilityCalculator[" << calcid_ << "]::run() , TotNbProcPaq=" << totprocnpaq_ << endl;
     /*
     for(size_t fib=0; fib<(size_t)memgr_.NbFibres(); fib++)  vpchk_[fib].Print();
@@ -280,10 +282,10 @@
   }
   catch (std::exception& exc) {
-    cout << " BRVisibilityCalculator::run()/catched std::exception " << exc.what() << endl;
+    cout << " BRVisibilityCalculator[" << calcid_ << "]::run()/catched std::exception " << exc.what() << endl;
     setRC(98);	
     return; 
   }
   catch(...) {
-    cout << " BRVisibilityCalculator::run()/catched unknown ... exception " << endl;
+    cout << " BRVisibilityCalculator[" << calcid_ << "]::run()/catched unknown ... exception " << endl;
     setRC(99);	
     return; 